Class | Haml::Engine
In: | lib/haml/engine.rb
Parent: | Object

This is the frontend for using Haml programmatically. It can be directly used by the user by creating a new instance and calling \{render} to render the template. For example:

        template = File.read('templates/really_cool_template.haml')
        haml_engine = Haml::Engine.new(template)
        output = haml_engine.render
        puts output

### Methods

def_method html4? html5? html? new options_for_buffer precompiled render render_proc to_html xhtml?

### Included Modules

Precompiler

### Attributes

indentation | [RW] | The indentation used in the Haml document, or `nil` if the indentation is ambiguous (for example, for a single-level document). @return [String]
options | [RW] | The options hash. See {file:HAML_REFERENCE.md#haml_options the Haml options documentation}. @return [{Symbol => Object}]

### Public Class methods

new(template, options = {})

Precompiles the Haml template.

@param template [String] The Haml template @param options [{Symbol => Object}] An options hash;

      see {file:HAML_REFERENCE.md#haml_options the Haml options documentation}

@raise [Haml::Error] if there‘s a Haml syntax error in the template

[Source]

         # File lib/haml/engine.rb, line 72
     72:     def initialize(template, options = {})
     73:       @options = {
     74:         :suppress_eval => false,
     75:         :attr_wrapper => "'",
     76:
     77:         # Don't forget to update the docs in doc-src/HAML_REFERENCE.md
     78:         # if you update these
     79:         :autoclose => %w[meta img link br hr input area param col base],
     80:         :preserve => %w[textarea pre code],
     81:
     82:         :filename => '(haml)',
     83:         :line => 1,
     84:         :ugly => false,
     85:         :format => :xhtml,
     86:         :escape_html => false,
     87:       }
     88:
     89:
     90:       template = check_haml_encoding(template) do |msg, line|
     91:         raise Haml::Error.new(msg, line)
     92:       end
     93:
     94:       unless ruby1_8?
     95:         @options[:encoding] = Encoding.default_internal || template.encoding
     96:         @options[:encoding] = "utf-8" if @options[:encoding].name == "US-ASCII"
     97:       end
     98:       @options.merge! options.reject {|k, v| v.nil?}
     99:       @index = 0
    100:
    101:       unless [:xhtml, :html4, :html5].include?(@options[:format])
    102:         raise Haml::Error, "Invalid format #{@options[:format].inspect}"
    103:       end
    104:
    105:       if @options[:encoding] && @options[:encoding].is_a?(Encoding)
    106:         @options[:encoding] = @options[:encoding].name
    107:       end
    108:
    109:       # :eod is a special end-of-document marker
    110:       @template = (template.rstrip).split(/\r\n|\r|\n/) + [:eod, :eod]
    111:       @template_index = 0
    112:       @to_close_stack = []
    113:       @output_tabs = 0
    114:       @template_tabs = 0
    115:       @flat = false
    116:       @newlines = 0
    117:       @precompiled = ''
    118:       @to_merge = []
    119:       @tab_change  = 0
    120:
    121:       precompile
    122:     rescue Haml::Error => e
    123:       if @index || e.line
    124:         e.backtrace.unshift "#{@options[:filename]}:#{(e.line ? e.line + 1 : @index) + @options[:line] - 1}"
    125:       end
    126:       raise
    127:     end

### Public Instance methods

def_method(object, name, *local_names)

Defines a method on `object` with the given name that renders the template and returns the result as a string.

If `object` is a class or module, the method will instead by defined as an instance method. For example:

        t = Time.now
        Haml::Engine.new("%p\n  Today's date is\n  .date= self.to_s").def_method(t, :render)
        t.render #=> "<p>\n  Today's date is\n  <div class='date'>Fri Nov 23 18:28:29 -0800 2007</div>\n</p>\n"

        Haml::Engine.new(".upcased= upcase").def_method(String, :upcased_div)
        "foobar".upcased_div #=> "<div class='upcased'>FOOBAR</div>\n"

The first argument of the defined method is a hash of local variable names to values. However, due to an unfortunate Ruby quirk, the local variables which can be assigned must be pre-declared. This is done with the `local_names` argument. For example:

        # This works
        obj = Object.new
        Haml::Engine.new("%p= foo").def_method(obj, :render, :foo)
        obj.render(:foo => "Hello!") #=> "<p>Hello!</p>"

        # This doesn't
        obj = Object.new
        Haml::Engine.new("%p= foo").def_method(obj, :render)
        obj.render(:foo => "Hello!") #=> NameError: undefined local variable or method `foo'

Note that Haml modifies the evaluation context (either the scope object or the `self` object of the scope binding). It extends {Haml::Helpers}, and various instance variables are set (all prefixed with `haml_`).

@param object [Object, Module] The object on which to define the method @param name [String, Symbol] The name of the method to define @param local_names [Array<Symbol>] The names of the locals that can be passed to the proc

[Source]

         # File lib/haml/engine.rb, line 272
    272:     def def_method(object, name, *local_names)
    273:       method = object.is_a?(Module) ? :module_eval : :instance_eval
    274:
    275:       object.send(method, "def #{name}(_haml_locals = {}); #{precompiled_with_ambles(local_names)}; end",
    276:                   @options[:filename], @options[:line])
    277:     end

html4?()

@return [Boolean] Whether or not the format is HTML4.

[Source]

        # File lib/haml/engine.rb, line 44
    44:     def html4?
    45:       @options[:format] == :html4
    46:     end

html5?()

@return [Boolean] Whether or not the format is HTML5.

[Source]

        # File lib/haml/engine.rb, line 49
    49:     def html5?
    50:       @options[:format] == :html5
    51:     end

html?()

@return [Boolean] Whether or not the format is any flavor of HTML.

[Source]

        # File lib/haml/engine.rb, line 39
    39:     def html?
    40:       html4? or html5?
    41:     end

precompiled()

The source code that is evaluated to produce the Haml document.

In Ruby 1.9, this is automatically converted to the correct encoding (see {file:HAML_REFERENCE.md#encoding-option the `:encoding` option}).

@return [String]

[Source]

        # File lib/haml/engine.rb, line 59
    59:     def precompiled
    60:       return @precompiled if ruby1_8?
    61:       encoding = Encoding.find(@options[:encoding])
    62:       return @precompiled.force_encoding(encoding) if encoding == Encoding::BINARY
    63:       return @precompiled.encode(encoding)
    64:     end

render(scope = Object.new, locals = {}, &block)

Processes the template and returns the result as a string.

`scope` is the context in which the template is evaluated. If it‘s a `Binding` or `Proc` object, Haml uses it as the second argument to `Kernel#eval`; otherwise, Haml just uses its `instance_eval` context.

Note that Haml modifies the evaluation context (either the scope object or the `self` object of the scope binding). It extends {Haml::Helpers}, and various instance variables are set (all prefixed with `haml_`). For example:

        s = "foobar"
        Haml::Engine.new("%p= upcase").render(s) #=> "<p>FOOBAR</p>"

        # s now extends Haml::Helpers
        s.respond_to?(:html_attrs) #=> true

`locals` is a hash of local variables to make available to the template. For example:

        Haml::Engine.new("%p= foo").render(Object.new, :foo => "Hello, world!") #=> "<p>Hello, world!</p>"

If a block is passed to render, that block is run when `yield` is called within the template.

Due to some Ruby quirks, if `scope` is a `Binding` or `Proc` object and a block is given, the evaluation context may not be quite what the user expects. In particular, it‘s equivalent to passing `eval("self", scope)` as `scope`. This won‘t have an effect in most cases, but if you‘re relying on local variables defined in the context of `scope`, they won‘t work.

@param scope [Binding, Proc, Object] The context in which the template is evaluated @param locals [{Symbol => Object}] Local variables that will be made available

      to the template

@param block [to_proc] A block that can be yielded to within the template @return [String] The rendered template

[Source]

         # File lib/haml/engine.rb, line 170
    170:     def render(scope = Object.new, locals = {}, &block)
    171:       buffer = Haml::Buffer.new(scope.instance_variable_get('@haml_buffer'), options_for_buffer)
    172:
    173:       if scope.is_a?(Binding) || scope.is_a?(Proc)
    174:         scope_object = eval("self", scope)
    175:         scope = scope_object.instance_eval{binding} if block_given?
    176:       else
    177:         scope_object = scope
    178:         scope = scope_object.instance_eval{binding}
    179:       end
    180:
    181:       set_locals(locals.merge(:_hamlout => buffer, :_erbout => buffer.buffer), scope, scope_object)
    182:
    183:       scope_object.instance_eval do
    184:         extend Haml::Helpers
    185:         @haml_buffer = buffer
    186:       end
    187:
    188:       eval(precompiled + ";" + precompiled_method_return_value,
    189:         scope, @options[:filename], @options[:line])
    190:     ensure
    191:       # Get rid of the current buffer
    192:       scope_object.instance_eval do
    193:         @haml_buffer = buffer.upper
    194:       end
    195:     end

render_proc(scope = Object.new, *local_names)

Returns a proc that, when called, renders the template and returns the result as a string.

`scope` works the same as it does for render.

The first argument of the returned proc is a hash of local variable names to values. However, due to an unfortunate Ruby quirk, the local variables which can be assigned must be pre-declared. This is done with the `local_names` argument. For example:

        # This works
        Haml::Engine.new("%p= foo").render_proc(Object.new, :foo).call :foo => "Hello!"
          #=> "<p>Hello!</p>"

        # This doesn't
        Haml::Engine.new("%p= foo").render_proc.call :foo => "Hello!"
          #=> NameError: undefined local variable or method `foo'

The proc doesn‘t take a block; any yields in the template will fail.

@param scope [Binding, Proc, Object] The context in which the template is evaluated @param local_names [Array<Symbol>] The names of the locals that can be passed to the proc @return [Proc] The proc that will run the template

[Source]

         # File lib/haml/engine.rb, line 222
    222:     def render_proc(scope = Object.new, *local_names)
    223:       if scope.is_a?(Binding) || scope.is_a?(Proc)
    224:         scope_object = eval("self", scope)
    225:       else
    226:         scope_object = scope
    227:         scope = scope_object.instance_eval{binding}
    228:       end
    229:
    230:       eval("Proc.new { |*_haml_locals| _haml_locals = _haml_locals[0] || {};" +
    231:            precompiled_with_ambles(local_names) + "}\n", scope, @options[:filename], @options[:line])
    232:     end

to_html(scope = Object.new, locals = {}, &block)

Alias for render

xhtml?()

@return [Boolean] Whether or not the format is XHTML.

[Source]

        # File lib/haml/engine.rb, line 34
    34:     def xhtml?
    35:       not html?
    36:     end

### Protected Instance methods

options_for_buffer()

Returns a subset of \{options}: those that {Haml::Buffer} cares about. All of the values here are such that when `inspect` is called on the hash, it can be `Kernel#eval`ed to get the same result back.

See {file:HAML_REFERENCE.md#haml_options the Haml options documentation}.

@return [{Symbol => Object}] The options hash

[Source]

         # File lib/haml/engine.rb, line 288
    288:     def options_for_buffer
    289:       {
    290:         :autoclose => @options[:autoclose],
    291:         :preserve => @options[:preserve],
    292:         :attr_wrapper => @options[:attr_wrapper],
    293:         :ugly => @options[:ugly],
    294:         :format => @options[:format],
    295:         :encoding => @options[:encoding],
    296:         :escape_html => @options[:escape_html],
    297:       }
    298:     end

[Validate]